#include ".\..\..\Source\inc\GameEngine.h"

typedef struct tagKEY_STATUS
{
	unsigned long pressed;
	unsigned long released;
	unsigned long status;
} KEY_STATUS;

extern "C" void kbd_get_status(KEY_STATUS* ks);

#define		SKEY_LEFT		0x10000000	//left
#define		SKEY_RIGHT		0x00040000	//right
#define		SKEY_UP			0x00100000	//up
#define		SKEY_DOWN		0x08000000	//down

#define		SKEY_SELECT		0x00000400
#define		SKEY_START		0x00000800

#define		SKEY_A			0x80000000	//1	//old_ENTER
#define 	SKEY_B			0x00200000	//2
#define		SKEY_X			0x00010000	//3
#define 	SKEY_Y			0x00000040	//4

#define		SKEY_LS			0x00000100
#define		SKEY_RS			0x20000000

#define		SKEY_POWER		0x00000080

extern bool g_bGameRuning ;
extern Char g_FilePath[256];
extern Char g_AppFullName[256];
extern "C" int sys_judge_event(void * fun);
extern "C" char *__to_locale_ansi(wchar_t *);

KEY_STATUS ks;
KEY_STATUS oldks;

extern "C" void onkey( Engine* pEng )
{
	kbd_get_status( &ks );
	
	//-------------------------------------
	//SKEY_LEFT
	if( ks.status & SKEY_LEFT ){
		pEng->m_pInput->KeyDown( KEY_LF );
	}else{
		if( oldks.status & SKEY_LEFT ) 
			pEng->m_pInput->KeyUp( KEY_LF );
	}
	//SKEY_RIGHT
	if( ks.status & SKEY_RIGHT ){
		pEng->m_pInput->KeyDown( KEY_RT );
	}else{
		if( oldks.status & SKEY_RIGHT ) 
			pEng->m_pInput->KeyUp( KEY_RT );
	}
	//SKEY_UP
	if( ks.status & SKEY_UP ){
		pEng->m_pInput->KeyDown( KEY_UP );
	}else{
		if( oldks.status & SKEY_UP ) {
			pEng->m_pInput->KeyUp( KEY_UP );
		}
	}
	//SKEY_DOWN
	if( ks.status & SKEY_DOWN ){
		pEng->m_pInput->KeyDown( KEY_DN );
	}else{
		if( oldks.status & SKEY_DOWN ) {
			pEng->m_pInput->KeyUp( KEY_DN );
		}
	}

	//-------------------------------------
	//SKEY_A - A
	if( ks.status & SKEY_A ){
		pEng->m_pInput->KeyDown( KEY_1 );
	}else{
			pEng->m_pInput->KeyUp( KEY_1 );
	}
	//SKEY_B - B
	if( ks.status &  SKEY_B ){
		pEng->m_pInput->KeyDown( KEY_2 );
	}else{
		if( oldks.status & SKEY_B ) 
			pEng->m_pInput->KeyUp( KEY_2 );
	}

	//SKEY_Y - Y
	if( ks.status & SKEY_Y ){
		 pEng->m_pInput->KeyDown( KEY_3 );
	}else{
		if( oldks.status & SKEY_Y )
		 	pEng->m_pInput->KeyUp( KEY_3 );
	}

	//SKEY_X  - X
	if( ks.status &  SKEY_X){
		pEng->m_pInput->KeyDown( KEY_4 );
	}else{
		if( oldks.status & SKEY_X ) 
			pEng->m_pInput->KeyUp( KEY_4 );
	}

	//-------------------------------------
	//SKEY_LS - L
	if( ks.status & SKEY_LS ){
		pEng->m_pInput->KeyDown( KEY_L2 );
	}else{
		if( oldks.status & SKEY_LS ) 
			pEng->m_pInput->KeyUp( KEY_L2 );
	}
	//SKEY_RS - R
	if( ks.status &  SKEY_RS){
		pEng->m_pInput->KeyDown( KEY_R2 );
	}else{
		if( oldks.status & SKEY_RS ) 
			pEng->m_pInput->KeyUp( KEY_R2 );
	}

	//-------------------------------------
	//SKEY_POWER - POWER
	if( ks.status &  SKEY_POWER){
		pEng->m_pInput->KeyDown( KEY_9 );
	}else{
		if( oldks.status & SKEY_POWER ) 
			pEng->m_pInput->KeyUp( KEY_9 );
	}

	// SKEY_START
	if( ks.status & SKEY_START) {
		pEng->m_pInput->KeyDown( KEY_R1 );
	}else{
		if( oldks.status & SKEY_START ) {
			pEng->m_pInput->KeyUp( KEY_R1 );
		}
	}

	// SELECT
	if( ks.status & SKEY_SELECT) {
		pEng->m_pInput->KeyDown( KEY_L1 );	//KEY_OK
	}else{
		if( oldks.status & SKEY_SELECT ) {
			pEng->m_pInput->KeyUp( KEY_L1 );	//KEY_OK
		}
	}

	oldks = ks;
}

GameEngine* pEng;

extern "C" int GameMain(char* respath)
{
	int ref = 1;
	int sysref = 0;
	Char AppFullName[256];
	char* fullpath;

//	LOG_ON;
	  
	strcpy((Char16*)AppFullName, (Char16*)respath);

	fullpath = __to_locale_ansi( (wchar_t*)respath );
	GetPathFromFilename( g_FilePath, fullpath );

	// ޸Ļֱ
	int SCREEN_WIDTH = 320;
	int	SCREEN_HEIGHT = 240;

	void* userdata[5];
	
	userdata[0] = AppFullName;
	userdata[1] = g_FilePath;
	userdata[2] = fullpath;
	userdata[3] = (void*)&SCREEN_WIDTH;
	userdata[4] = (void*)&SCREEN_HEIGHT;

	pEng = new GameEngine( userdata );
//	LOG(_LS("h"));
	pEng->Init();
	pEng->Start();

	g_bGameRuning = true;
	oldks.status = 0;
	 
	while( g_bGameRuning ){
		sysref = sys_judge_event( NULL);
		if( sysref  < 0 ){
			ref = sysref ;
			break;
		}
		onkey( pEng );

		pEng->OneFrame();
	}
	pEng->Stop();
	SAFE_DELETE( pEng );

	return ref;
}
