/*
 * xrick/src/sysarg.c
 *
 * Copyright (C) 1998-2002 BigOrno (bigorno@bigorno.net). All rights reserved.
 *
 * The use and distribution terms for this software are contained in the file
 * named README, which can be found in the root of this distribution. By
 * using this software in any fashion, you are agreeing to be bound by the
 * terms of this license.
 *
 * You must not remove this notice, or any other, from this software.
 */

/*
 * 20021010 added test to prevent buffer overrun in -keys parsing.
 */

#include <stdlib.h>  /* atoi */
#include <string.h>  /* strcasecmp */

#include "system.h"
#include "config.h"
#include "game.h"

#include "maps.h"
#include "syssnd.h"

/* handle Microsoft Visual C (must come after system.h!) */
#ifdef __MSVC__
#define strcasecmp stricmp
#endif

#define _strcmp strcmp

typedef struct {
  char name[16];
  int code;
} sdlcodes_t;


int sysarg_args_period = 0;
int sysarg_args_map = 0;
int sysarg_args_submap = 0;
int sysarg_args_fullscreen = 0;
int sysarg_args_zoom = 0;
int sysarg_args_nosound = 0;
int sysarg_args_vol = 0;
char *sysarg_args_data = NULL;

/*
 * Fail
 */
void
sysarg_fail(char *msg)
{
	exit(1);
}

/*
 * Scan key codes sequence
 */
int
sysarg_scankeys(char *keys)
{
//  char k[16];
//  int i, j;
//
//  i = 0;
//
//  j = 0;
//  while (keys[i] != '\0' && keys[i] != '-' && j + 1 < sizeof k) k[j++] = keys[i++];
//  if (keys[i++] == '\0') return -1;
//  k[j] = '\0';
//  syskbd_left = sysarg_sdlcode(k);
//  if (!syskbd_left) return -1;
//
//  j = 0;
//  while (keys[i] != '\0' && keys[i] != '-' && j + 1 < sizeof k) k[j++] = keys[i++];
//  if (keys[i++] == '\0') return -1;
//  k[j] = '\0';
//  syskbd_right = sysarg_sdlcode(k);
//  if (!syskbd_right) return -1;
//
//  j = 0;
//  while (keys[i] != '\0' && keys[i] != '-' && j + 1 < sizeof k) k[j++] = keys[i++];
//  if (keys[i++] == '\0') return -1;
//  k[j] = '\0';
//  syskbd_up = sysarg_sdlcode(k);
//  if (!syskbd_up) return -1;
//
//  j = 0;
//  while (keys[i] != '\0' && keys[i] != '-' && j + 1 < sizeof k) k[j++] = keys[i++];
//  if (keys[i++] == '\0') return -1;
//  k[j] = '\0';
//  syskbd_down = sysarg_sdlcode(k);
//  if (!syskbd_down) return -1;
//
//  j = 0;
//  while (keys[i] != '\0' && keys[i] != '-' && j + 1 < sizeof k) k[j++] = keys[i++];
//  if (keys[i] != '\0') return -1;
//  k[j] = '\0';
//  syskbd_fire = sysarg_sdlcode(k);
//  if (!syskbd_fire) return -1;

  return 0;
}

/*
 * Read and process arguments
 */
void
sysarg_init(int argc, char **argv)
{


  /* this is dirty (sort of) */
  if (sysarg_args_submap > 0 && sysarg_args_submap < 9)
    sysarg_args_map = 0;
  if (sysarg_args_submap >= 9 && sysarg_args_submap < 20)
    sysarg_args_map = 1;
  if (sysarg_args_submap >= 20 && sysarg_args_submap < 38)
    sysarg_args_map = 2;
  if (sysarg_args_submap >= 38)
    sysarg_args_map = 3;
  if (sysarg_args_submap == 9 ||
      sysarg_args_submap == 20 ||
      sysarg_args_submap == 38)
    sysarg_args_submap = 0;

}

/* eof */





